import interpreter.Expr.*
import interpreter.NumOp.*
import interpreter.PairOp.*
import interpreter.ExprHelpers.*
import interpreter.*

def strictEval(e: Expr) =
  val strictEval = StrictInterpreterWithCounter()
  val strictResult = strictEval.topLevelEvaluate(e)
  val strictRecursions = strictEval.counter
  (strictResult, strictRecursions)

def lazyEval(e: Expr) =
  val lazyEval = LazyInterpreterWithCounter()
  val lazyResult = lazyEval.topLevelEvaluate(e)
  val lazyRecursions = lazyEval.counter
  (lazyResult, lazyRecursions)

simple1
strictEval(simple1)
lazyEval(simple1)

// Try other predefined test expressions from ExprHelpers, or test your own.
val e = Let("x", NumExpr(Div, Num(1), Num(0)), Var("x"))
strictEval(e)
